{
	SceneManager.update = function(deltaTime){
		Graphics.tickStart();
		try {
			const giveUpFrameCount = 60;
			const maxRepeatNumber = 6;
			
			// Add to total time
			this._elapsedTime += deltaTime;
			
			// If we're behind by a substantial amount, give up on catching up
			if (this._elapsedTime >= giveUpFrameCount) {
				this._elapsedTime = 1;
			}
			
			// Determine number of times to repeat logic updates for this rendered frame
			let repeatNumber = 0;
			while (repeatNumber < maxRepeatNumber && this._elapsedTime >= 1) {
				repeatNumber++;
				this._elapsedTime -= 1;
			}
			
			for (let i = 0; i < repeatNumber; i++) {
				this.updateManagers();
				this.updateMain();
			}
		} catch (e) {
			this.catchException(e);
		}
		this.renderScene();
		Graphics.tickEnd();
	};
}